from collections import deque, defaultdict

def find_guarded_warehouse(n, m, k, roads, guards):
    graph = defaultdict(list)
    for a, b in roads:
        graph[a].append(b)
        graph[b].append(a)

    guarded = set()

    for p, h in guards:
        queue = deque([(p, h)])
        visited = set()

        while queue:
            current, stamina = queue.popleft()
            if current in visited or stamina < 0:
                continue

            guarded.add(current)
            visited.add(current)

            for neighbor in graph[current]:
                if neighbor not in visited:
                    queue.append((neighbor, stamina - 1))

    guarded_list = sorted(guarded)
    return len(guarded_list), guarded_list

n, m, k = map(int, input().split())
roads = [tuple(map(int, input().split())) for _ in range(m)]
guards = [tuple(map(int, input().split())) for _ in range(k)]

count, guarded_warehouse = find_guarded_warehouse(n, m, k, roads, guards)

print(count)
if count > 0:
    print(" ".join(map(str, guarded_warehouse)))